%define name			MySQL
%define version			3.23.54a
%define release			1.3mdk
%define major			10
%define libname_orig		libmysql
%define libname			%{libname_orig}%{major}

%define shared_lib_version	10:0:0
%define mysqld_user		mysql
%define var			/var
%define localstatedir		%{var}/lib
%define distribution		Mandrake Linux (RedBox)

%define see_base For a description of MySQL see the base MySQL RPM or http://www.mysql.com

Summary:        MySQL: a very fast and reliable SQL database engine

Group:		Databases

Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Packager: 	Zdenek BluHawk Mazanec <bluehawk@betateam.com>
Vendor:		RedBox team Contactel s.r.o.
Source:		http://www.mysql.com/Downloads/MySQL-3.23/mysql-%{version}.tar.bz2
Patch0:		mysql-3.23.51-init.patch.bz2
Patch1:		mysql-3.23.42-bench.patch.bz2
Patch2:		convert.cc.patch.bz2
Patch3:		mysql-3.23.51-other-libc.patch.bz2
Patch4:		mysql-3.23.54a-errno.patch.bz2

Icon:		mysql.gif
URL:		http://www.mysql.com

Provides:	msqlormysql MySQL-server mysqlserver
Requires:	MySQL-client
Requires:	perl-DBI
# * cbelisle@mandrakesoft.com 2001/12/07
# Cheap way to get off of MySQL-devel, but the conflict below was not working.
# I still don't know why the conflict was not working.
Obsoletes:	mysql MySQL-devel <= 3.23.39
Provides:	mysql
#Conflicts:	MySQL-devel <= 3.23.39

BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	db3-devel
BuildRequires:	gcc-c++
BuildRequires:	libtermcap-devel
BuildRequires:	ncurses-devel
BuildRequires:	python
BuildRequires:	tetex
BuildRequires:	texinfo
BuildRequires:	zlib-devel

BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
MySQL is a true multi-user, multi-threaded SQL (Structured Query
Language) database server. MySQL is a client/server implementation
that consists of a server daemon (mysqld) and many different client
programs/libraries.


The main goals of MySQL are speed, robustness and ease of use.  MySQL
was originally developed because we needed a SQL server that could
handle very big databases with magnitude higher speed than what any
database vendor could offer to us. And since we did not need all the
features that made their server slow we made our own. We have now been
using MySQL since 1996 in a environment with more than 40 databases,
10,000 tables, of which more than 500 have more than 7 million
rows. This is about 200G of data.

The base upon which MySQL is built is a set of routines that have been
used in a highly demanding production environment for many
years. While MySQL is still in development, it already offers a rich
and highly useful function set.

Changes: default-charset=czech, all char. sets, patched convert.cc
See the documentation for more information. 

%package client
Summary:	MySQL - Client
Group:		Databases

Obsoletes:	mysql-client
Provides:	mysql-client
Requires:	%{libname} = %{version}-%{release}
Requires:	perl-CGI

%description client
This package contains the standard MySQL clients.

%{see_base}

%package bench
Summary:	MySQL - Benchmarks and test system
Group:		Databases

Obsoletes:	mysql-bench
Provides:	mysql-bench
Requires:       MySQL-client = %{version}-%{release} perl-Mysql perl perl-GD

%description bench
This package contains MySQL benchmark scripts and data.

%{see_base}

%package -n %{libname}-devel
Summary:	MySQL - Development header files and libraries
Group:		Development/Other
Obsoletes:	MySQL-devel mysql-devel
Provides:	MySQL-devel = %{version}-%{release} mysql-devel = %{version}-%{release} %{libname_orig}-devel = %{version}-%{release}
Requires:	%{libname} = %{version} MySQL = %{version}-%{release} MySQL-client = %{version}-%{release}

%description -n %{libname}-devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.

%{see_base}

%package -n %{libname}
Summary:	MySQL - Shared libraries
Group:		System/Libraries
Obsoletes:	MySQL-shared-libs MySQL-shared
Provides:	MySQL-shared-libs = %{version}-%{release} MySQL-shared = %{version}-%{release}

%description -n %{libname}
This package contains the shared libraries (*.so*) which certain
languages and applications need to dynamically load and use MySQL.

%prep
%setup -q -n mysql-%{version}

# cb(28/01/02) no longer needed
#rm -rf $RPM_BUILD_ROOT
#%setup -T -c -n mysql-%{version}
#cd ..
#bzip2 -dc %{SOURCE0}| tar xif -
#cd mysql-%{version}
#chmod a-s sql-bench -R
#chmod g-w sql-bench -R

%patch0 -p1 -b .server-stop
%patch1
%patch2
#%patch3 -p1 -b .other-libc
#%patch4 -p1 -b .errno

%build

%serverbuild

# Use the build root for temporary storage of the shared libraries.

RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/mysql-%{version}
if test -z "$RBR" -o "$RBR" = "/"
then
	echo "RPM_BUILD_ROOT has stupid value"
	exit 1
fi
rm -rf $RBR
mkdir -p $RBR

PATH="${MYSQL_BUILD_PATH:-/usr/local/bin:/bin:%{_bindir}}" \
	CC="${MYSQL_BUILD_CC:-gcc}" \
	CFLAGS="${MYSQL_BUILD_CFLAGS:-$RPM_OPT_FLAGS}" \
	CXX="${MYSQL_BUILD_CXX:-g++}" \
	CXXFLAGS="${MYSQL_BUILD_CXXFLAGS:-$RPM_OPT_FLAGS}" \
	./configure \
	    --enable-shared --enable-thread-safe-client \
	    --enable-assembler \
            --with-mysqld-user=%{mysqld_user} \
            --with-unix-socket-path=/var/lib/mysql/mysql.sock \
            --prefix=/ \
	    --with-extra-charsets=all \
            --exec-prefix=%{_prefix} \
            --libexecdir=%{_sbindir} \
            --sysconfdir=%{_sysconfdir} \
            --datadir=%{_datadir} \
            --localstatedir=%{localstatedir}/mysql \
            --infodir=%{_infodir} \
            --includedir=%{_includedir} \
            --mandir=%{_mandir} \
	    --with-berkeley-db \
	    --without-innobase \
	    --with-raid \
	    --with-language=czech \
	    --with-charset=czech \
	    --with-comment="%{distribution} MySQL RPM"

# benchdir does not fit in above model. Maybe a separate bench distribution
make benchdir=$RPM_BUILD_ROOT%{_datadir}

# Save shared libraries
(cd libmysql/.libs; tar cf $RBR/shared-libs.tar *.so*)
(cd libmysql_r/.libs; tar rf $RBR/shared-libs.tar *.so*)

nm --numeric-sort sql/mysqld > sql/mysqld.sym

%install -n mysql-%{version}
RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/mysql-%{version}
# Ensure that needed directories exists
install -d $RBR%{_sysconfdir}/{logrotate.d,rc.d/init.d}
install -d $RBR%{localstatedir}/mysql/mysql
install -d $RBR%{_datadir}/sql-bench
install -d $RBR%{_datadir}/mysql-test
install -d $RBR%{_sbindir}
install -d $RBR%{_datadir}
install -d $RBR%{_mandir}
install -d $RBR%{_includedir}
install -d $RBR%{_infodir}
install -d $RBR%{_docdir}/%{name}-%{version}
install -d $RBR%{_libdir}
# Make install

make install DESTDIR=$RBR benchdir_root=%{_datadir}

# Install shared libraries (Disable for architectures that don't support it)
(cd $RBR%{_libdir}; tar xf $RBR/shared-libs.tar)

# install symbol files ( for stack trace resolution)
install -m644 $MBD/sql/mysqld.sym $RBR/usr/lib/mysql/mysqld.sym

# Install logrotate and autostart
install -m644 $MBD/support-files/mysql-log-rotate $RBR%{_sysconfdir}/logrotate.d/MySQL
install -m755 $MBD/support-files/mysql.server $RBR/etc/rc.d/init.d/mysql

# Install docs
install -m644 $RPM_BUILD_DIR/mysql-%{version}/Docs/mysql.info \
 $RBR%{_infodir}/mysql.info
for file in README COPYING COPYING.LIB Docs/manual_toc.html Docs/manual.html \
    Docs/manual.txt Docs/manual.texi Docs/manual.ps \
    support-files/my-huge.cnf support-files/my-large.cnf \
    support-files/my-medium.cnf support-files/my-small.cnf
do
    b=`basename $file`
    install -m644 $MBD/$file $RBR%{_docdir}/MySQL-%{version}/$b
done

#Fix libraries
mv $RBR%{_libdir}/mysql/libmysqlclient.* ${RBR}%{_libdir}/
mv $RBR%{_libdir}/mysql/libmysqlclient_r.* ${RBR}%{_libdir}/
perl -pi -e "s/usr\/lib\/mysql/usr\/lib/" ${RBR}%{_libdir}/libmysqlclient.la
perl -pi -e "s/usr\/lib\/mysql/usr\/lib/" ${RBR}%{_libdir}/libmysqlclient_r.la

# Make mysqlrepair, mysqlanalyze and mysqloptimize
pushd $RBR%{_bindir}
ln -sf mysqlcheck mysqlrepair
ln -sf mysqlcheck mysqlanalyze
ln -sf mysqlcheck mysqloptimize
popd

%clean
#[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%pre
if test -x /etc/rc.d/init.d/mysql
then
  /etc/rc.d/init.d/mysql stop > /dev/null 2>&1
  sleep 5
fi

%post
%_install_info mysql.info

mysql_datadir=%{localstatedir}/mysql
# Create data directory if needed
if test ! -d $mysql_datadir;		then mkdir $mysql_datadir; fi
if test ! -d $mysql_datadir/mysql;	then mkdir $mysql_datadir/mysql; fi
if test ! -d $mysql_datadir/test;	then mkdir $mysql_datadir/test; fi

# Make MySQL start/shutdown automatically when the machine does it.
%_post_service mysql
# Create a MySQL user. Do not report any problems if it already
# exists. This is redhat specific and should be handled more portable
useradd -M -r -d $mysql_datadir -s /bin/bash -c "MySQL server" mysql 2> /dev/null || true
# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R mysql $mysql_datadir
# Initiate databases
mysql_install_db -IN-RPM > /dev/null
# Change permissions again to fix any new files.
chown -R mysql $mysql_datadir
# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw $mysql_datadir/mysql
# Restart in the same way that mysqld will be started normally.
if [ $1 = 0 ]; then
	/etc/rc.d/init.d/mysql restart > /dev/null
fi
# Allow safe_mysqld to start mysqld and print a message before we exit
sleep 2

# cb(28/01/02) Add the stop procedure to preun
%preun
if test $1 = 0
then
  if test -x /etc/rc.d/init.d/mysql
  then
    /etc/rc.d/init.d/mysql stop > /dev/null
  fi
fi
	  
%_preun_service mysql
%_remove_install_info mysql.info

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc %{_docdir}/MySQL-%{version}/
%{_bindir}/isamchk
%{_bindir}/isamlog
%{_bindir}/pack_isam
%{_bindir}/myisamchk
%{_bindir}/myisamlog
%{_bindir}/myisampack
%{_bindir}/mysql_fix_privilege_tables
%{_bindir}/mysql_convert_table_format
%{_bindir}/mysql_install_db
%{_bindir}/mysql_setpermission
%{_bindir}/mysql_zap
%{_bindir}/mysqlbug
%{_bindir}/mysqltest
%{_bindir}/mysqlhotcopy
%{_bindir}/perror
%{_bindir}/replace
%{_bindir}/resolveip
%{_bindir}/resolve_stack_dump
%{_bindir}/safe_mysqld
%{_bindir}/mysqld_multi
%{_bindir}/my_print_defaults
%{_infodir}/mysql.info*
%{_sbindir}/mysqld
%{_libdir}/mysql/mysqld.sym
%config(noreplace) %{_sysconfdir}/*
%{_datadir}/mysql/
%{_bindir}/mysql_config
%{_mandir}/man1/mysqld.1*
%{_mandir}/man1/mysqld_multi.1*
%{_mandir}/man1/mysql_zap.1*
%{_mandir}/man1/isamchk.1*
%{_mandir}/man1/isamlog.1*
%{_mandir}/man1/safe_mysqld.1*

%files client
%defattr(-,root,root)
%{_bindir}/msql2mysql
%{_bindir}/mysql
%{_bindir}/mysqlaccess
%{_bindir}/mysqladmin
%{_bindir}/mysqlcheck
%{_bindir}/mysqlrepair
%{_bindir}/mysqlanalyze
%{_bindir}/mysqloptimize
%{_bindir}/mysql_find_rows
%{_bindir}/mysqldump
%{_bindir}/mysqlimport
%{_bindir}/mysqlshow
%{_bindir}/mysqlbinlog
%{_bindir}/comp_err
%{_mandir}/man1/mysql.1*
%{_mandir}/man1/mysqlaccess.1*
%{_mandir}/man1/mysqladmin.1*
%{_mandir}/man1/mysqldump.1*
%{_mandir}/man1/mysqlshow.1*

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%doc INSTALL-SOURCE
%{_libdir}/mysql/*.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/*.a
%{_includedir}/mysql/

%files bench
%defattr(-,root,root)
%doc sql-bench/README
%{_datadir}/sql-bench/*
%{_datadir}/mysql-test/*

%changelog
* Mon Dec 16 2002 Vincent Danen <vdanen@mandrakesoft.com> 3.23.47-5.2mdk
- rework security patch

* Thu Dec 12 2002 Vincent Danen <vdanen@mandrakesoft.com> 3.23.47-5.1mdk
- security update for 8.2

* Wed Mar 06 2002 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.47-5mdk
- Add a require on perl-CGI in MySQL-client.
- Add a require on perl-DBI in MySQL.

* Wed Feb 20 2002 Christian Belisle <cbelisle@mandrakesoft.com> 3.23-47-4mdk
- Fix %%post section (mysqld restart)

* Tue Jan 29 2002 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.47-3mdk
- Fix dangling symlink for mysqlcheck.
- No messages to user when upgrading.
- Add symbol file.
- Add a stop procedure to %%preun.
- Move mysqlcheck to MySQL-client.

* Tue Jan 22 2002 Stefan van der Eijk <stefan@eijk.nu> 3.23.47-2mdk
- BuildRequires

* Fri Jan 04 2002 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.47-1mdk
- 3.23.47.

* Wed Dec 05 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.46-4mdk
- Fix conflict problem (Obsolete it).

* Mon Dec 03 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.46-3mdk
- I didn't add mysqlrepair in MySQL-client, it's in the base package.
- Added mysqlcheck, mysqlanalyze and mysqloptimize in base package.

* Mon Dec 03 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.46-2mdk
- s/sysconfdir/_sysconfdir/.
- Make a "legal" lib package.
- Added missing man files.
- Added mysqlrepair in MySQL-client.

* Sun Dec 02 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.46-1mdk
- 3.23.46.

* Mon Nov 26 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.45-1mdk
- 3.23.45.

* Tue Nov 06 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.44-2mdk
- Fix source permissions (rpmlint)

* Tue Nov 06 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.44-1mdk
- Remake the patch for the init script. (thanx to Ian)
- 3.23.44.

* Tue Oct 09 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.43-1mdk
- 3.23.43.

* Sun Sep 30 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.42-1mdk
- 3.23.42.
- Fixed logrotate file name.

* Thu Sep 13 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.41-5mdk
- Added version and release in the Requires.

* Fri Aug 31 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.41-4mdk
- Remove Obsolete in MySQL-devel.
- Remove Distribution tag.

* Fri Aug 31 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.41-3mdk
- rebuild

* Thu Aug 30 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.41-2mdk
- Make scripts in MySQL-bench functional.
- Provides the Obsoletes to keep the dependencies.
- Make rpmlint happier.

* Mon Aug 13 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.41-1mdk
- New version 3.23.41.

* Tue Aug 07 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.40-5mdk
- Moved the libmysqlclient* and libmysqlclient_r* to /usr/lib.

* Tue Jul 31 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.40-4mdk
- Finally fixed the conflict with mysql_config.

* Fri Jul 27 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.40-3mdk
- Still a problem with /usr/bin/mysql_config. Should be fixed.

* Fri Jul 27 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.40-2mdk
- Fixed a conflict with /usr/bin/mysql_config.

* Fri Jul 27 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.40-1mdk
- 3.23.40.

* Sun Jul 15 2001 Jeff Garzik <jgarzik@mandrakesoft.com> 3.23.39-5mdk
- Remove alpha-specific bits.
- Remove 'v' flag from tar in %%prep stage

* Fri Jul 13 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.39-4mdk
- Fixed %post command.
- Require for MySQL on devel package.
- Patch to add status and restart command in init file.

* Fri Jul 13 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.39-3mdk
- Typo in the version number in the changelog.
- Fixed Distribution Tag.

* Fri Jul 13 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.39-2mdk
- Changed libtermcap-devel for libtermcap2-devel.
- s/Copyright/License
- Removed the Release tag in the sub packages.
- Removed language reference in the package.
- Removed the permissions specifications on each file.
- Removed all the SunOS related things.

* Fri Jun 22 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.39-1mdk
- 3.23.39.

* Thu May 31 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.38-2mdk
- Applied a patch to fix the TMPDIR problem (was yelling errors
  with default TMPDIR).

* Thu May 24 2001 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.38-1mdk
- Updated to 3.23.38 to correct bugs

* Mon Apr  9 2001 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.23.36-2mdk
- use serberbuild and post_service macros
- macroize a bit more

* Thu Apr 05 2001 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.23.36-1mdk
- 3.23.36 version, a series of bugfixes
- Put missing files in .spec
- Removed mysqlbug conflict (was in client and server packages)

* Thu Feb 13 2001 Geoffrey Lee <snailtalk@mandrakesoft.com> 3.23.33-1mdk
- 3.23.33 update.

* Sat Jan 20 2001 Vincent Danen <vdanen@mandrakesoft.com> 3.23.31-1mdk
- 3.23.31; security fixes

* Fri Nov 17 2000 David BAUDENS <baudens@mandrakesoft.com> 3.23.23-2mdk
- Rebuild with gcc-2.96 & glibc-2.2

* Sat Sep 02 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.23.23-1mdk
- Updated to 3.23.23 to correct php segfaults
- Added separate libmysql_r directory; now both a threaded
  and non-threaded library is shipped.

* Tue Aug 09 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.23.22-2mdk
- Put libmysqlclient.so in devel package

* Mon Aug 07 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.23.22-1mdk
- Updated to 3.23.22
  (this is a beta version, but starting from 3.23.19, the license is
   GPL, so we prefer the beta to the non-GPL stable tree)
- Macroize
- Merged with the spec from David Axmark <davida@mysql.com>
  :Added the support-files/my-example.cnf to the docs directory.
  :Removed devel dependency on base since it is about client
   development.
  :The --enable-assembler switch is now automatically disables on
   platforms there assembler code is unavailable. This should allow
   building this RPM on non i386 systems.

* Tue May 16 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.22.32-6mdk
- Recompile with egcs on alpha.

* Tue Apr 18 2000 Pixel <pixel@mandrakesoft.com> 3.22.32-5mdk
- disable starting of mysql while in install

* Thu Apr 06 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.22.32-4mdk
- fix bench perms

* Thu Apr 06 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.22.32-3mdk
- cleaned spec file

* Mon Apr 03 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 3.22.32-2mdk
- new group

* Mon Feb 27 2000 Jean-Michel Dault <jmdault@netrevolution.com> 3.22.32-1mdk
- updated to 3.22.32 - security updates

* Wed Jan 19 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 3.22.30

* Mon Jan  3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- final cleanup for Mandrake 7

* Mon Jan 3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 3.22.29

* Wed Dec 31 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- rebuilt for Mandrake 7.0

* Sat Dec 12 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 3.22.27

* Wed Sep 1 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- put the shared libs in separate package
- fixed dependancies

* Thu Aug 19 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- added fr locale
- Mandrake adaptations
- Solaris adaptations

* Mon Feb 22 1999 David Axmark <david@detron.se>
- Removed unportable cc switches from the spec file. The defaults can
  now be overridden with environment variables. This feature is used
  to compile the official RPM with optimal (but compiler version
  specific) switches.

- Removed the repetitive description parts for the sub rpms. Maybe add
  again if RPM gets a multiline macro capability.

- Added support for a pt_BR translation. Translation contributed by
  Jorge Godoy <jorge@bestway.com.br>.

* Wed Nov 4 1998 David Axmark <david@detron.se>
- A lot of changes in all the rpm and install scripts. This may even
  be a working RPM :-)

* Sun Aug 16 1998 David Axmark <david@detron.se>
- A developers changelog for MySQL is available in the source RPM. And
  there is a history of major user visible changed in the Reference
  Manual.  Only RPM specific changes will be documented here.

